- 300. 最长递增子序列
- 题目
- 题解
给你一个整数数组 nums ,找到其中最长严格递增子序列的长度。
子序列 是由数组派生而来的序列,删除(或不删除)数组中的元素而不改变其余元素的顺序。例如,[3,6,2,7] 是数组 [0,3,1,6,2,2,7] 的子序列。
示例 1:
输入:nums = [10,9,2,5,3,7,101,18] 输出:4 解释:最长递增子序列是 [2,3,7,101],因此长度为 4 。
示例 2:
输入:nums = [0,1,0,3,2,3] 输出:4
示例 3:
输入:nums = [7,7,7,7,7,7,7] 输出:1
提示:
1 <= nums.length <= 2500
-104 <= nums[i] <= 104
进阶:
你能将算法的时间复杂度降低到 O(n log(n)) 吗?
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/longest-increasing-subsequence
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
多阶段决策+最优解,尝试使用动态规划。
确定dp数组及其下标的含义
dp[i]:以nums[i]结尾的严格递增子序列的长度为dp[i]
dp数组递推式
dp[i]的值为以nums[i]结尾的严格递增子序列的长度,所以我们需要从i-1开始往前找比nums[i]小的数nums[j],比nums[i]小的数肯定有很多,选择dp[j]最大的一个nums[j]形成新的严格递增子序列。
如果没找到就以nums[i]开头为新的严格递增子序列。
for(let i=0;ifor(let j=i;j>=0;j--){ if(nums[j] dp数组初始化
dp数组初始化为1,表示以自己开头、自己结尾的严格递增子序列的长度为1let dp = new Array(nums.length).fill(1) ;代码
var lengthOfLIS = function(nums) { let dp = new Array(nums.length).fill(1) ; let res = 1; for(let i=0;ifor(let j=i;j>=0;j--){ if(nums[j]



